/**
 * @file main.c
 * Exemplos de conversao implicita e explicita entre tipos de dados
 * 
 * @author Wu Shin Ting
 * @date 19/08/2020
 */

/**
 * @brief programa-demo da conversao entre tipos de dados
 */
int main(void)
{
	// declarar as variaveis
	char c_valor = 225;
	char copia_1, copia_2;
	int counter = 0;
	float a, b, c;
	
	char *end_c_valor_1, *end_c_valor_2;
	
	// Bloco 1
	// dividir dois operandos inteiros -> resultado em inteiro
	a = 2/4;
	b = (float)(2/4);
	// dividir um operando em ponto flutuante por um operando inteiro 
	c = ((float)2)/4;
	
	// Bloco 2
	// ler o endereco de uma variavel por duas formas
	end_c_valor_1 = &c_valor;
	
	end_c_valor_2 = (char *)(0x20002fe1);
	
	// Bloco 3
	// copiar o conteudo do endereco armazenado num ponteiro de duas formas
	copia_1 = *end_c_valor_1;
	
	copia_2 = *((char *)(0x20002fe1));
	
	for(;;) {	  
		// Bloco 4
	   	counter++;
	   	
	   	// converter explicitamente um tipo de 4 bytes para um tipo de 1 byte
	   	c_valor = (char)counter;
	}
	
	return 0;
}
